.H3 "Inside a Makefile"
.Command make
uses a
.File Makefile
file to tell it what to do.  The
.File Makefile
is a relatively complicated file, but you don't normally need to do anything
with it.  Still, it's useful to understand some of the structure.  Here's a
fictive 
.File Makefile
based roughly on a ports
.File Makefile .
The original is in
.File /usr/ports/editors/emacs21/Makefile .
As you can see, it's much more complicated.
.Dx
# New ports collection makefile for:	GNU emacs
# Date created:		11 October 2001

PORTNAME=	emacs
PORTVERSION=	21.2
PORTREVISION=	2
CATEGORIES=	editors ipv6
MAN1=		ctags.1 emacs.1 etags.1 gfdl.1
DESTDIR?=	/usr/local

foo:		foo.o bar.o baz.o
		${CC} foo.o bar.o baz.o -o foo

install:	all
		cp ${WRKSRC}/src/emacs ${DESTDIR}/bin

\&.include <bsd.port.mk>
.De
This extract shows a number of things:
.Ls B
.LI
The first few lines are comments, starting with the \f(CW#\fP character.
.LI
Next come some variable assignments.  They are almost the same as shell
environment variables, which we discussed on page
.Sref \*[environment-variables] .
Note particularly the variable \f(CWDESTDIR\fP: the assignment is with the
operator \f(CW?=\fP, which means ``only perform this assignment if the variable
is not already defined''.
.LI
Next comes a rule.  It has three parts:
.Ls
.LI
\f(CWfoo\fP is called the \fItarget\fP, the name by which you invoke the rule:
in this case you would write \f(CWmake foo\fP.  The intention here is to make
a file called
.File -n foo .
.LI
\f(CWfoo.o\fP, \f(CWbar.o\fP and \f(CWbaz.o\fP are called \fIdependencies\fP.
Dependencies can be file names or the names other targets.  In this case they
look like file names, though you can't be sure.
.LI
Any following lines are commands to be performed.  In this case, the single
command compiles
.File -n emacs
from the source file
.File -n emacs.c
.Le
.LI
The final line tells
.Command make
to read in the file
.File /usr/share/mk/bsd.port.mk
before performing any commands.
.Le
The trick with
.Command make
is how it handles dependencies.  Rules can have multiple dependencies,
frequently a very large number.  In 

If the file
.File -n emacs
exists and is newer than all the file dependencies, and none of the target
dependencies need to be performed, nothing happens.  Otherwise
.Command make
performs the target dependencies first, and then performs the \fIrules\fP\/
which follow


.Ls
.LI
\f(CWinstall\fB is called the \fItarget\fP.  It can be a file name, or it can be
an arbitrary name, as in this case.

and in fact they can be

